Can anyone tell me how to solve this problem?
http://codeforces.me/contest/177/problem/G2
Thanks in advance!
Can anyone tell me how to solve this problem?
http://codeforces.me/contest/177/problem/G2
Thanks in advance!
| № | Пользователь | Рейтинг |
|---|---|---|
| 1 | Benq | 3676 |
| 2 | Kevin114514 | 3659 |
| 3 | jiangly | 3640 |
| 4 | turmax | 3450 |
| 5 | tourist | 3382 |
| 6 | strapple | 3360 |
| 7 | Um_nik | 3354 |
| 8 | squareOf105 | 3348 |
| 9 | maroonrk | 3312 |
| 10 | idontwannadothis…e | 3191 |
| Страны | Города | Организации | Всё → |
| № | Пользователь | Вклад |
|---|---|---|
| 1 | Qingyu | 155 |
| 2 | nik_exists | 151 |
| 3 | maspy | 149 |
| 4 | AmShZ | 145 |
| 5 | Um_nik | 143 |
| 6 | Errichto | 139 |
| 7 | BledDest | 136 |
| 8 | adamant | 134 |
| 9 | maroonrk | 132 |
| 10 | cry | 130 |
| Название |
|---|



This is enhanced version of one problem in ICPC WF 2012: https://icpc.kattis.com/problems/fibonacci
Short editorial for WF 2012: http://www.csc.kth.se/~austrin/icpc/finals2012solutions.pdf
I "guess" matrix exponentiation will do the trick for enhanced version (unproven for now, I didn't have time to analyse further).
Let's calculate for each prefix s[1..i] the minimum fibonacci index minind[i] such that s[1..i] is a suffix of fib[i] and s[i + 1..n] is a prefix of fib[i + 1].
Because the relation
can be written equivalently as:
it follows that $min_ind[i]$ is either ∞ or less than n (because fib[i] has all the prefixes of fib[i - 2]). After that, it is essentially a linear reccurence of type
for all $\i \geq n$ (or n + 2 or smth.).
You basically have to compute DP[n] and DP[n + 1] and occurences_less_than_inf, and then do matrix exp. I think that should work :).